'''just like make waifu'''
import json
import re
from glob import glob
import random

reply_pattern = re.compile(r">>([0-9]+)")

posts = {}
threads = {}
for filename in glob("*.json"):
    thread = json.load(open(filename))
    thread_id = thread["threadId"]
    message = thread["message"]
    reply_to = [int(x) for x in reply_pattern.findall(message)]
    posts[thread_id] = {
        "message": message,
        "sage": thread["email"] == "sage",
        "name": thread["name"],
        "creation": thread["creation"],
        "thread": True,
        "reply_to": reply_to,
        "mentioned_by": [],
        "thread_id": thread_id,
        "post_id": thread_id
    }    
    
    for post in thread['posts']:
        name = post['name']
        post_id = post['postId']
        message = post['message']
        reply_to = [int(x) for x in reply_pattern.findall(message)]
        reply_to.append(thread_id)
        posts[post_id] = {
            "message": message,
            "sage": post['email'] == "sage",
            "name": post['name'],
            "creation": post['creation'],
            "thread": False,
            "reply_to": sorted(list(set(reply_to)), reverse=True),
            "mentioned_by": [],
            "thread_id": thread_id,
            "post_id": post['postId']
        }

for post_id in posts:
    for reply_to_id in posts[post_id]["reply_to"]:
        if reply_to_id in posts:
            posts[reply_to_id]["mentioned_by"].append(post_id)
        #else:
        #    print(f"No.{reply_to_id} mentioned but was deleted")

def chain(post, seen):
    seen.add(post["post_id"])
    post_chain = [post["post_id"]]
    for post_id in post["reply_to"]:
        if post_id in seen: # prevent loops
            continue
        if post_id not in posts:
            #print(f"No.{post_id} not found")
            continue
        post_chain = chain(posts[post_id], seen) + post_chain
    return post_chain

def print_message(post):
    print(f"{post['name']}{' (SAGE)' if post['sage'] else ''} {post['creation'].replace('T', ' ')[:-5]} No.{post['post_id']}\n{post['message']}\n===")

def print_messages(chain):
    for post_id in chain:
        print_message(posts[post_id])

post_ids = sorted(posts.keys())
random.shuffle(post_ids)
for post_id in post_ids:
    c = chain(posts[post_id], set())
    print_messages(c)
    print("<|endoftext|>")
